# Training Sessions 3: Path Planning

This session will give a gentle introduction to the different planning algorithms that are available to us.

Planning is essential both for offline planning of the intended path we want the robot to follow, but even more essential for online replanning on the robot, to avoid colliding with obstacles.

The implemented algorithms are forked from: https://github.com/zhm-real/path-planning-algorithms


## Initial Setup
> NOTE: This exercise is meant to be run in the Docker container, but you are free to run it how you see fit, but you will be on your own when encountering issues.

First we need to install python virtualenvironment, so open a terminal and execute the following

```bash
sudo apt-get update && sudo apt-get install -y python3.8-venv
```
Next, you need to create a virtualenvironment to install some python packages into, this is done to avoid clashing with some of the python packages needed by the ROS installation.
In the terminal type the following
```bash
python3 -m venv ~/.venv && source ~/.venv/bin/activate
```
Now you should see a terminal like this:
```bash
(.venv) ubuntu@<some number>:/$
```
where the `(.venv)` indicates that your virtualenvironment is active.

Now install `jupyterlab` by running

```bash
pip install jupyterlab
```

Start the jupyter server by running:

```bash
jupyter lab --browser=Firefox
```

Firefox should open automatically to a page looking like this:

![](./media/jupyter_startup.png)

Now navigate to the folder `34763-autonomous-marine-robotics/Training Sessions/TS3 Path Planning` using the navigation pane on the left side (as shown in the image).

> TIP:
> You can render this readme file directly in jupyterlab as well, open the file, and move it to the right side of the , and right-click in the content and select `Show Markdown Preview`, now right-click the markdown tab and select `New view for Markdown File` - This way you can follow along in the same browser tab!


## Exercise 1

Run through the notebook `exe1_search_based.ipynb`.
This will give you an introduction to some of the search based planning algorithms discussed in the lecture.

## Exercise 2.1

Run through the notebook `exe2_sampling_based.ipynb`.

## Exercise 2.2

Run through the notebook `exe3_sampling_based_seachart.ipynb`.

## Exercise 3.1 - Running the path planning simulation using ROS

The ROS workspace is at “Training_Sessions/TS3_Path_Planning/ts3_ws”
You need to compile it by:

```
cd /home/ubuntu/34763-autonomous-marine-robotics/Training_Sessions/TS3_Path_Planning/ts3_ws
catkin_make
```

How to run the simulation:
  - Run the BlueROV Gazebo (the default GUI is off):
```
source devel/setup.bash
roslaunch ts3_path_planning start_pid_demo_lake.launch
```

  - Open a new terminal and run the map publisher, path planner and path follower:
```
cd /home/ubuntu/34763-autonomous-marine-robotics/Training_Sessions/TS3_Path_Planning/ts3_ws
source devel/setup.bash
roslaunch ts3_path_planning run.launch
```

  - Open a new terminal and publish the goal position:
```
cd /home/ubuntu/34763-autonomous-marine-robotics/Training_Sessions/TS3_Path_Planning/ts3_ws
source devel/setup.bash
roslaunch ts3_path_planning publish_goal.launch
```

## Exercise 3.2 - Add a new A* path planner ROS node

- Duplicate `dijkstra_planner.py`
- Add heuristic function (See the code from the Exercise 1): `TS3_Path_Planning\Search_based_Planning\Search_2D\Astar.py`
- Add a new or modify the ROS launch file to call your new ROS node: `run.launch`
- Update the `CMakeLists.txt` (adding your new python file) and compile (`catkin_make`)

## Exercise 4 - 3D path planning
- Duplicate and extend `exe2_1_sampling_based.ipynb` to 3D. 
- The classes are available in: `TS3_Path_Planning/Sampling_based_Planning/Search_3D`

<!-- 
Forked from: https://github.com/zhm-real/path-planning-algorithms

Install dependency:

'''
python -m pip install -r requirements.txt
'''

Overview
------
This repository implements some common path planning algorithms used in robotics, including Search-based algorithms and Sampling-based algorithms. We designed animation for each algorithm to display the running process. The related papers are listed in [Papers](https://github.com/zhm-real/PathPlanning#papers).

Directory Structure
------
    .
    └── Search-based Planning
        ├── Breadth-First Searching (BFS)
        ├── Depth-First Searching (DFS)
        ├── Best-First Searching
        ├── Dijkstra's
        ├── A*
        ├── Bidirectional A*
        ├── Anytime Repairing A*
        ├── Learning Real-time A* (LRTA*)
        ├── Real-time Adaptive A* (RTAA*)
        ├── Lifelong Planning A* (LPA*)
        ├── Dynamic A* (D*)
        ├── D* Lite
        └── Anytime D*
    └── Sampling-based Planning
        ├── RRT
        ├── RRT-Connect
        ├── Extended-RRT
        ├── Dynamic-RRT
        ├── RRT*
        ├── Informed RRT*
        ├── RRT* Smart
        ├── Anytime RRT*
        ├── Closed-Loop RRT*
        ├── Spline-RRT*
        ├── Fast Marching Trees (FMT*)
        └── Batch Informed Trees (BIT*)
    └── Papers

## Animations - Search-Based
### Best-First & Dijkstra
<div align=right>
<table>
  <tr>
    <td><img src="https://github.com/zhm-real/path-planning-algorithms/blob/master/Search_based_Planning/gif/BF.gif" alt="dfs" width="400"/></a></td>
    <td><img src="https://github.com/zhm-real/path-planning-algorithms/blob/master/Search_based_Planning/gif/Dijkstra.gif" alt="dijkstra" width="400"/></a></td>
  </tr>
</table>
</div>

### A* and A* Variants
<div align=right>
<table>
  <tr>
    <td><img src="https://github.com/zhm-real/path-planning-algorithms/blob/master/Search_based_Planning/gif/Astar.gif" alt="astar" width="400"/></a></td>
    <td><img src="https://github.com/zhm-real/path-planning-algorithms/blob/master/Search_based_Planning/gif/Bi-Astar.gif" alt="biastar" width="400"/></a></td>
  </tr>
</table>
<table>
  <tr>
    <td><img src="https://github.com/zhm-real/path-planning-algorithms/blob/master/Search_based_Planning/gif/RepeatedA_star.gif" alt="repeatedastar" width="400"/></a></td>
    <td><img src="https://github.com/zhm-real/path-planning-algorithms/blob/master/Search_based_Planning/gif/ARA_star.gif" alt="arastar" width="400"/></a></td>
  </tr>
</table>
<table>
  <tr>
    <td><img src="https://github.com/zhm-real/path-planning-algorithms/blob/master/Search_based_Planning/gif/LRTA_star.gif" alt="lrtastar" width="400"/></a></td>
    <td><img src="https://github.com/zhm-real/path-planning-algorithms/blob/master/Search_based_Planning/gif/RTAA_star.gif" alt="rtaastar" width="400"/></a></td>
  </tr>
</table>
<table>
  <tr>
    <td><img src="https://github.com/zhm-real/path-planning-algorithms/blob/master/Search_based_Planning/gif/D_star.gif" alt="lpastar" width="400"/></a></td>
    <td><img src="https://github.com/zhm-real/path-planning-algorithms/blob/master/Search_based_Planning/gif/LPAstar.gif" alt="dstarlite" width="400"/></a></td>
  </tr>
</table>
<table>
  <tr>
    <td><img src="https://github.com/zhm-real/path-planning-algorithms/blob/master/Search_based_Planning/gif/ADstar_small.gif" alt="lpastar" width="400"/></a></td>
    <td><img src="https://github.com/zhm-real/path-planning-algorithms/blob/master/Search_based_Planning/gif/ADstar_sig.gif" alt="dstarlite" width="400"/></a></td>
  </tr>
</table>
</div>

## Animation - Sampling-Based
### RRT & Variants
<div align=right>
<table>
  <tr>
    <td><img src="https://github.com/zhm-real/PathPlanning/blob/master/Sampling_based_Planning/gif/RRT_2D.gif" alt="value iteration" width="400"/></a></td>
    <td><img src="https://github.com/zhm-real/PathPlanning/blob/master/Sampling_based_Planning/gif/Goal_biasd_RRT_2D.gif" alt="value iteration" width="400"/></a></td>
  </tr>
</table>
<table>
  <tr>
    <td><img src="https://github.com/zhm-real/PathPlanning/blob/master/Sampling_based_Planning/gif/RRT_CONNECT_2D.gif" alt="value iteration" width="400"/></a></td>
    <td><img src="https://github.com/zhm-real/PathPlanning/blob/master/Sampling_based_Planning/gif/Extended_RRT_2D.gif" alt="value iteration" width="400"/></a></td>
  </tr>
</table>
<table>
  <tr>
    <td><img src="https://github.com/zhm-real/PathPlanning/blob/master/Sampling_based_Planning/gif/Dynamic_RRT_2D.gif" alt="value iteration" width="400"/></a></td>
    <td><img src="https://github.com/zhm-real/PathPlanning/blob/master/Sampling_based_Planning/gif/RRT_STAR2_2D.gif" alt="value iteration" width="400"/></a></td>
  </tr>
</table>
<table>
  <tr>
    <td><img src="https://github.com/zhm-real/PathPlanning/blob/master/Sampling_based_Planning/gif/RRT_STAR_SMART_2D.gif" alt="value iteration" width="400"/></a></td>
    <td><img src="https://github.com/zhm-real/PathPlanning/blob/master/Sampling_based_Planning/gif/FMT.gif" alt="value iteration" width="400"/></a></td>
  </tr>
</table>
<table>
  <tr>
    <td><img src="https://github.com/zhm-real/PathPlanning/blob/master/Sampling_based_Planning/gif/INFORMED_RRT_STAR_2D3.gif" alt="value iteration" width="400"/></a></td>
    <td><img src="https://github.com/zhm-real/PathPlanning/blob/master/Sampling_based_Planning/gif/BIT2.gif" alt="value iteration" width="400"/></a></td>
  </tr>
</table>
</div>

## Papers
### Search-base Planning
* [A*: ](https://ieeexplore.ieee.org/document/4082128) A Formal Basis for the heuristic Determination of Minimum Cost Paths
* [Learning Real-Time A*: ](https://arxiv.org/pdf/1110.4076.pdf) Learning in Real-Time Search: A Unifying Framework
* [Real-Time Adaptive A*: ](http://idm-lab.org/bib/abstracts/papers/aamas06.pdf) Real-Time Adaptive A*
* [Lifelong Planning A*: ](https://www.cs.cmu.edu/~maxim/files/aij04.pdf) Lifelong Planning A*
* [Anytime Repairing A*: ](https://papers.nips.cc/paper/2382-ara-anytime-a-with-provable-bounds-on-sub-optimality.pdf) ARA*: Anytime A* with Provable Bounds on Sub-Optimality
* [D*: ](http://web.mit.edu/16.412j/www/html/papers/original_dstar_icra94.pdf) Optimal and Efficient Path Planning for Partially-Known Environments
* [D* Lite: ](http://idm-lab.org/bib/abstracts/papers/aaai02b.pdf) D* Lite
* [Field D*: ](http://robots.stanford.edu/isrr-papers/draft/stentz.pdf) Field D*: An Interpolation-based Path Planner and Replanner
* [Anytime D*: ](http://www.cs.cmu.edu/~ggordon/likhachev-etal.anytime-dstar.pdf) Anytime Dynamic A*: An Anytime, Replanning Algorithm
* [Focussed D*: ](http://robotics.caltech.edu/~jwb/courses/ME132/handouts/Dstar_ijcai95.pdf) The Focussed D* Algorithm for Real-Time Replanning
* [Potential Field, ](https://journals.sagepub.com/doi/abs/10.1177/027836498600500106) [[PPT]: ](https://www.cs.cmu.edu/~motionplanning/lecture/Chap4-Potential-Field_howie.pdf) Real-Time Obstacle Avoidance for Manipulators and Mobile Robots
* [Hybrid A*: ](https://ai.stanford.edu/~ddolgov/papers/dolgov_gpp_stair08.pdf) Practical Search Techniques in Path Planning for Autonomous Driving

### Sampling-based Planning
* [RRT: ](http://msl.cs.uiuc.edu/~lavalle/papers/Lav98c.pdf) Rapidly-Exploring Random Trees: A New Tool for Path Planning
* [RRT-Connect: ](http://www-cgi.cs.cmu.edu/afs/cs/academic/class/15494-s12/readings/kuffner_icra2000.pdf) RRT-Connect: An Efficient Approach to Single-Query Path Planning
* [Extended-RRT: ](http://citeseerx.ist.psu.edu/viewdoc/download?doi=10.1.1.1.7617&rep=rep1&type=pdf) Real-Time Randomized Path Planning for Robot Navigation
* [Dynamic-RRT: ](https://www.ri.cmu.edu/pub_files/pub4/ferguson_david_2006_2/ferguson_david_2006_2.pdf) Replanning with RRTs
* [RRT*: ](https://journals.sagepub.com/doi/abs/10.1177/0278364911406761) Sampling-based algorithms for optimal motion planning
* [Anytime-RRT*: ](https://dspace.mit.edu/handle/1721.1/63170) Anytime Motion Planning using the RRT*
* [Closed-loop RRT* (CL-RRT*): ](http://acl.mit.edu/papers/KuwataTCST09.pdf) Real-time Motion Planning with Applications to Autonomous Urban Driving
* [Spline-RRT*: ](https://ieeexplore.ieee.org/abstract/document/6987895?casa_token=B9GUwVDbbncAAAAA:DWscGFLIa97ptgH7NpUQUL0A2ModiiBDBGklk1z7aDjI11Kyfzo8rpuFstdYcjOofJfCjR-mNw) Optimal path planning based on spline-RRT* for fixed-wing UAVs operating in three-dimensional environments
* [LQR-RRT*: ](https://lis.csail.mit.edu/pubs/perez-icra12.pdf) Optimal Sampling-Based Motion Planning with Automatically Derived Extension Heuristics
* [RRT#: ](http://dcsl.gatech.edu/papers/icra13.pdf) Use of Relaxation Methods in Sampling-Based Algorithms for Optimal Motion Planning
* [RRT*-Smart: ](http://save.seecs.nust.edu.pk/pubs/ICMA2012.pdf) Rapid convergence implementation of RRT* towards optimal solution
* [Informed RRT*: ](https://arxiv.org/abs/1404.2334) Optimal Sampling-based Path Planning Focused via Direct Sampling of an Admissible Ellipsoidal heuristic
* [Fast Marching Trees (FMT*): ](https://arxiv.org/abs/1306.3532) a Fast Marching Sampling-Based Method for Optimal Motion Planning in Many Dimensions
* [Motion Planning using Lower Bounds (MPLB): ](https://ieeexplore.ieee.org/document/7139773) Asymptotically-optimal Motion Planning using lower bounds on cost
* [Batch Informed Trees (BIT*): ](https://arxiv.org/abs/1405.5848) Sampling-based Optimal Planning via the Heuristically Guided Search of Implicit Random Geometric Graphs
* [Advanced Batch Informed Trees (ABIT*): ](https://arxiv.org/abs/2002.06589) Sampling-Based Planning with Advanced Graph-Search Techniques ((ICRA) 2020)
* [Adaptively Informed Trees (AIT*): ](https://arxiv.org/abs/2002.06599) Fast Asymptotically Optimal Path Planning through Adaptive Heuristics ((ICRA) 2020) -->
